      subroutine alfabeta (alpha,beta)
      implicit none
      real*8 alpha, beta
      integer*4 N
      parameter (N=100)
      integer*4 NT, itemp, isalt
      parameter (itemp=1, isalt=2)
      parameter (NT=2)
      real*8 pi, g, rho0, Cp, ods, ds, day2sec, sec2day,
     &                                  deg2rad, rad2deg
      parameter (pi=3.14159265358979323846,
     &           g=9.81, rho0=1025., Cp=3985.0,
     &           ods=N, ds=1./ods,
     &           day2sec=86400., sec2day=1./86400.,
     &           deg2rad=pi/180., rad2deg=180./pi)
      real*8 z_r(N),z_w(0:N),Hz(N), hmax, theta_s
      common /grid/ z_r,z_w,Hz,hmax,theta_s
      real*8 u(N,2),   v(N,2),  w(0:N),   t(N,2,NT),
     &     rhop0(N), rho1(N), bvf(0:N), tnudge(N,NT),  delta(N)
      common /ocean/ u,v,w,t, rhop0, rho1, bvf, tnudge, delta
      real*8 time,tdays
      integer*4 iic,nstp,nnew
      common /time_indices/ time,tdays,iic,nstp,nnew
      real*8 dt, f, R0,Tcoef,Scoef, twrite
      integer*4 ntstart,ntimes,nwrite,noutput,nplot
      common /scalars/ ntstart,ntimes,nwrite,noutput,nplot,
     &                 dt,f,twrite,R0,Tcoef,Scoef
      real*8      Q00, Q01, Q02, Q03, Q04, Q05, U00, U01, U02, U03,
     &          U04, V00, V01, V02, W00,    Tt, Ts, sqrtTs, cff
      parameter(Q00=+999.842594 , Q01=+6.793952E-2, Q02=-9.095290E-3,
     &          Q03=+1.001685E-4, Q04=-1.120083E-6, Q05=+6.536332E-9,
     &          U00=+0.824493   , U01=-4.08990E-3 , U02=+7.64380E-5 ,
     &          U03=-8.24670E-7 , U04=+5.38750E-9 , V00=-5.72466E-3 ,
     &          V01=+1.02270E-4 , V02=-1.65460E-6 , W00=+4.8314E-4  )
      Tt=t(N,nstp,itemp)
      Ts=t(N,nstp,isalt)
      sqrtTs=sqrt(Ts)
      cff=1./(1000.+rhop0(N))
      alpha=-cff*(Q01+Tt*(2.*Q02+Tt*(3.*Q03+Tt*(4.*Q04+Tt*5.*Q05)))
     &                    +Ts*(U01+Tt*(2.*U02+Tt*(3.*U03+Tt*4.*U04))
     &                                      +sqrtTs*(V01+Tt*2.*V02))
     &                                                            )
      beta= cff*(U00+Tt*(U01+Tt*(U02+Tt*(U03+Tt*U04)))+1.5*(V00+
     &                        Tt*(V01+Tt*V02) )*sqrtTs+2.*W00*Ts)
      return
      end
