      subroutine bulk_flux
      implicit none
      integer*4 N
      parameter (N=100)
      integer*4 NT, itemp, isalt
      parameter (itemp=1, isalt=2)
      parameter (NT=2)
      real*8 pi, g, rho0, Cp, ods, ds, day2sec, sec2day,
     &                                  deg2rad, rad2deg
      parameter (pi=3.14159265358979323846,
     &           g=9.81, rho0=1025., Cp=3985.0,
     &           ods=N, ds=1./ods,
     &           day2sec=86400., sec2day=1./86400.,
     &           deg2rad=pi/180., rad2deg=180./pi)
      real*8 z_r(N),z_w(0:N),Hz(N), hmax, theta_s
      common /grid/ z_r,z_w,Hz,hmax,theta_s
      real*8 u(N,2),   v(N,2),  w(0:N),   t(N,2,NT),
     &     rhop0(N), rho1(N), bvf(0:N), tnudge(N,NT),  delta(N)
      common /ocean/ u,v,w,t, rhop0, rho1, bvf, tnudge, delta
      real*8 sustr,svstr,srflx,stflx(NT),upwi
      common /forces/ sustr,svstr,srflx,stflx,upwi
      real*8 sustr_m(12), svstr_m(12), stflx_m(12),
     &     ssflx_m(12), sst_m(12), dqdt_m(12), srflx_m(12), upwi_m(12)
      common /forces_m/ sustr_m, svstr_m, stflx_m,
     &                  ssflx_m, sst_m, dqdt_m, srflx_m, upwi_m
      real*8 sstsk, dtw1
      common /forces_sstsk/ sstsk, dtw1
      real*8 lonr,latr,
     &     radsw,radlw,prate,tair,rhum,uwnd,vwnd,wspd
      common /forces_bulk/ lonr,latr,
     &     radsw,radlw,prate,tair,rhum,uwnd,vwnd,wspd
      real*8 radsw_m(12),radlw_m(12),prate_m(12),
     &     tair_m(12),rhum_m(12),uwnd_m(12),vwnd_m(12)
      common /forces_bulk_m/ radsw_m,radlw_m,prate_m,
     &                       tair_m,rhum_m,uwnd_m,vwnd_m
      real*8 shflx_rsw,shflx_lat,shflx_sen,shflx_rlw
      common /forces_bulk_out/ shflx_rsw,shflx_lat,shflx_sen,shflx_rlw
      real*8 time,tdays
      integer*4 iic,nstp,nnew
      common /time_indices/ time,tdays,iic,nstp,nnew
      real*8 dt, f, R0,Tcoef,Scoef, twrite
      integer*4 ntstart,ntimes,nwrite,noutput,nplot
      common /scalars/ ntstart,ntimes,nwrite,noutput,nplot,
     &                 dt,f,twrite,R0,Tcoef,Scoef
      integer*4 Itermax,Iter
      real*8 a,cff
      real*8 rho0i,cpi
      real*8 TseaC,TseaK,Qsea
      real*8 TairC,TairK,rhoAir,Qair
      real*8 Q,RH,VisAir,Hlv
      real*8 delW,delT,delQ
      real*8 u10,Zo10,Cd10,Ch10,Ct10,Cd
      real*8 Ct,CC,Ri,Ribcu,Zetu,L10
      real*8 Wstar,Tstar,Qstar
      real*8 ZoW,ZoT,ZoT10,ZoQ,ZoL,L,Rr,Bf
      real*8 Wpsi,Tpsi,Qpsi
      real*8 wspd0,Wgus,charn
      real*8 bulk_psiu,bulk_psit
      real*8 hfsen,hflat,hflw,upvel,evap
      real*8 blk_Rgas,blk_ZW,blk_ZT,blk_ZQ,blk_beta,blk_Cpa,blk_Zabl
      parameter (blk_Rgas=287.1)
      parameter (blk_ZW=10.0)
      parameter (blk_ZT=10.0)
      parameter (blk_ZQ=10.0)
      parameter (blk_Zabl=600.0)
      parameter (blk_beta=1.2)
      parameter (blk_Cpa=1004.67)
      real*8 emiss_lw,SigmaSB
      parameter (emiss_lw=0.985)
      parameter (SigmaSB=5.6697E-8)
      real*8 rhow,patm
      parameter (rhow=1000.0)
      parameter (patm=1010.0)
      real*8 eps,r3
      parameter (eps=1.d-20)
      parameter (r3=1.0/3.0)
      real*8 vonKar
      parameter (vonKar=0.41)
      real*8 aer,cer
      rho0i=1.0/rho0
      cpi=1.0/cp
      wspd0=wspd
      TairC=tair
      TairK=TairC+273.16
      TseaC=sstsk
      TseaK=TseaC+273.16
      RH=rhum
      hflw=radlw-emiss_lw*rho0i*cpi*SigmaSB*TseaK*TseaK*TseaK*TseaK
      cff=(1.0007+3.46e-6*patm)*6.1121*
     &    exp(17.502*TairC/(240.97+TairC))
      Qair=0.62197*(cff/(patm-0.378*cff))
      if (RH.lt.2.0) then
        cff=cff*RH
        Q=0.62197*(cff/(patm-0.378*cff))
      else
        Q=RH/1000.0
      endif
      cff=(1.0007+3.46e-6*patm)*6.1121*
     &        exp(17.502*TseaC/(240.97+TseaC))
      cff=cff*0.98
      Qsea=0.62197*(cff/(patm-0.378*cff))
      rhoAir=patm*100.0/(blk_Rgas*TairK*
     &                          (1.0+0.61*Q))
      VisAir=1.326E-5*(1.0+TairC*(6.542E-3+TairC*
     &           (8.301e-6-4.84e-9*TairC)))
      Hlv=(2.501-0.00237*TseaC)*1.0e+6
      Wgus=0.5
      delW=SQRT(wspd0*wspd0+Wgus*Wgus)
      delQ=Qsea-Q
      delT=TseaC-TairC
      ZoW=0.0001
      u10=delW*LOG(10.0/ZoW)/LOG(blk_ZW/ZoW)
      Wstar=0.035*u10
      Zo10=0.011*Wstar*Wstar/g+0.11*VisAir/Wstar
      Cd10=(vonKar/LOG(10.0/Zo10))**2
      Ch10=0.00115
      Ct10=Ch10/sqrt(Cd10)
      ZoT10=10.0/exp(vonKar/Ct10)
      Cd=(vonKar/LOG(blk_ZW/Zo10))**2
      Ct=vonKar/LOG(blk_ZT/ZoT10)
      CC=vonKar*Ct/Cd
      Ribcu=-blk_ZW/(blk_Zabl*0.004*blk_beta**3)
      Ri=-g*blk_ZW*(delT+0.61*TairK*delQ)/
     &      (TairK*delW*delW)
      if (Ri.lt.0.0) then
        Zetu=CC*Ri/(1.0+Ri/Ribcu)
      else
        Zetu=CC*Ri/(1.0+3.0*Ri/CC)
      endif
      L10=blk_ZW/Zetu
      if (Zetu.gt.50.0) then
        IterMax=1
      else
        IterMax=3
      endif
      Wstar=delW*vonKar/(LOG(blk_ZW/Zo10)-
     &                         bulk_psiu(blk_ZW/L10,pi))
      Tstar=-delT*vonKar/(LOG(blk_ZT/ZoT10)-
     &          bulk_psit(blk_ZT/L10,pi))
      Qstar=-delQ*vonKar/(LOG(blk_ZQ/ZoT10)-
     &          bulk_psit(blk_ZQ/L10,pi))
      if (delW.gt.18.0) then
        charn=0.018
      elseif ((10.0.lt.delW).and.(delW.le.18.0)) then
        charn=0.011+0.125*(0.018-0.011)*(delW-10.)
      else
        charn=0.011
      endif
      do Iter=1,IterMax
        ZoW=charn*Wstar*Wstar/g+0.11*VisAir/(Wstar+eps)
        Rr=ZoW*Wstar/VisAir
        ZoQ=MIN(1.15e-4,5.5e-5/Rr**0.6)
        ZoT=ZoQ
        ZoL=vonKar*g*blk_ZW*
     &           (Tstar*(1.0+0.61*Q)+0.61*TairK*Qstar)/
     &           (TairK*Wstar*Wstar*(1.0+0.61*Q)+eps)
        L=blk_ZW/(ZoL+eps)
        Wpsi=bulk_psiu(ZoL,pi)
        Tpsi=bulk_psit(blk_ZT/L,pi)
        Qpsi=bulk_psit(blk_ZQ/L,pi)
        Wstar=MAX(eps,delW*vonKar/(LOG(blk_ZW/ZoW)-Wpsi))
        Tstar=-delT*vonKar/(LOG(blk_ZT/ZoT)-Tpsi)
        Qstar=-delQ*vonKar/(LOG(blk_ZQ/ZoQ)-Qpsi)
        Bf=-g/TairK*Wstar*(Tstar+0.61*TairK*Qstar)
        if (Bf.gt.0.0) then
          Wgus=blk_beta*(Bf*blk_Zabl)**r3
        else
          Wgus=0.2
        endif
        delW=SQRT(wspd0*wspd0+Wgus*Wgus)
      enddo
      wspd0=SQRT(wspd0*wspd0+Wgus*Wgus)
      Cd=Wstar*Wstar/(wspd0*wspd0+eps)
      hfsen=-blk_Cpa*rhoAir*Wstar*Tstar
      hflat=-Hlv*rhoAir*Wstar*Qstar
      upvel=-1.61*Wstar*Qstar-(1.0+1.61*Q)*Wstar*Tstar/TairK
      hflat=hflat+rhoAir*Hlv*upvel*Q
      hflat=-hflat*rho0i*cpi
      hfsen=-hfsen*rho0i*cpi
      stflx(itemp)=radsw+hflw+hflat+hfsen
      evap=-cp*hflat/Hlv
      stflx(isalt)=(evap-prate)*t(N,nstp,isalt)
      shflx_rsw=rho0*cp*radsw
      shflx_lat=rho0*cp*hflat
      shflx_sen=rho0*cp*hfsen
      shflx_rlw=rho0*cp*hflw
      aer=rhoAir*wspd0*rho0i
      cer=Cd
      sustr=aer*cer*uwnd
      svstr=aer*cer*vwnd
      return
      end
      FUNCTION bulk_psiu (ZoL, pi)
      real*8 bulk_psiu
      real*8 ZoL, pi
      real*8 r3
      parameter (r3=1.0/3.0)
      real*8 Fw, cff, psic, psik, x, y
      if (ZoL.lt.0.0) then
        x=(1.0-15.0*ZoL)**0.25
        psik=2.0*LOG(0.5*(1.0+x))+LOG(0.5*(1.0+x*x))-
     &       2.0*ATAN(x)+0.5*pi
        cff=SQRT(3.0)
        y=(1.0-10.15*ZoL)**r3
        psic=1.5*LOG(r3*(1.0+y+y*y))-
     &       cff*ATAN((1.0+2.0*y)/cff)+pi/cff
        cff=ZoL*ZoL
        Fw=cff/(1.0+cff)
        bulk_psiu=(1.0-Fw)*psik+Fw*psic
      else
        cff=MIN(50.0,0.35*ZoL)
        bulk_psiu=-((1.0+ZoL)+0.6667*(ZoL-14.28)/
     &            EXP(cff)+8.525)
      endif
      return
      END FUNCTION bulk_psiu
      FUNCTION bulk_psit (ZoL, pi)
      real*8 bulk_psit
      real*8 ZoL, pi
      real*8 r3
      parameter (r3=1.0/3.0)
      real*8 Fw, cff, psic, psik, x, y
      if (ZoL.lt.0.0) then
        x=(1.0-15.0*ZoL)**0.5
        psik=2.0*LOG(0.5*(1.0+x))
        cff=SQRT(3.0)
        y=(1.0-34.15*ZoL)**r3
        psic=1.5*LOG(r3*(1.0+y+y*y))-
     &       cff*ATAN((1.0+2.0*y)/cff)+pi/cff
        cff=ZoL*ZoL
        Fw=cff/(1.0+cff)
        bulk_psit=(1.0-Fw)*psik+Fw*psic
      else
        cff=MIN(50.0,0.35*ZoL)
        bulk_psit=-((1.0+2.0*ZoL)**1.5+
     &            0.6667*(ZoL-14.28)/EXP(cff)+8.525)
      endif
      return
      END FUNCTION bulk_psit
