      subroutine lmd_kpp
      implicit none
      integer*4 N
      parameter (N=100)
      integer*4 NT, itemp, isalt
      parameter (itemp=1, isalt=2)
      parameter (NT=2)
      real*8 pi, g, rho0, Cp, ods, ds, day2sec, sec2day,
     &                                  deg2rad, rad2deg
      parameter (pi=3.14159265358979323846,
     &           g=9.81, rho0=1025., Cp=3985.0,
     &           ods=N, ds=1./ods,
     &           day2sec=86400., sec2day=1./86400.,
     &           deg2rad=pi/180., rad2deg=180./pi)
      integer*4 k, kbl
      real*8
     &    surf_dpth, dpth,
     &         Bo,
     &      Bosol,
     &      Bfsfc(0:N),Bfsfc_bl,
     &     stable,
     &         f1,
     &        Gm1,
     &     dGm1dS,
     &        Gt1,
     &     dGt1dS,
     &        Gs1,
     &     dGs1dS,
     &     Cr(0:N)
      real*8 alpha,beta, zscale,swdk,wm,ws, ustar
      real*8 hekman,  hmonob,
     &     cff,cff_up,cff_dn, K_bl,dK_bl, sgm, a1,a2,a3
      real*8 z_r(N),z_w(0:N),Hz(N), hmax, theta_s
      common /grid/ z_r,z_w,Hz,hmax,theta_s
      real*8 u(N,2),   v(N,2),  w(0:N),   t(N,2,NT),
     &     rhop0(N), rho1(N), bvf(0:N), tnudge(N,NT),  delta(N)
      common /ocean/ u,v,w,t, rhop0, rho1, bvf, tnudge, delta
      real*8 sustr,svstr,srflx,stflx(NT),upwi
      common /forces/ sustr,svstr,srflx,stflx,upwi
      real*8 sustr_m(12), svstr_m(12), stflx_m(12),
     &     ssflx_m(12), sst_m(12), dqdt_m(12), srflx_m(12), upwi_m(12)
      common /forces_m/ sustr_m, svstr_m, stflx_m,
     &                  ssflx_m, sst_m, dqdt_m, srflx_m, upwi_m
      real*8 sstsk, dtw1
      common /forces_sstsk/ sstsk, dtw1
      real*8 lonr,latr,
     &     radsw,radlw,prate,tair,rhum,uwnd,vwnd,wspd
      common /forces_bulk/ lonr,latr,
     &     radsw,radlw,prate,tair,rhum,uwnd,vwnd,wspd
      real*8 radsw_m(12),radlw_m(12),prate_m(12),
     &     tair_m(12),rhum_m(12),uwnd_m(12),vwnd_m(12)
      common /forces_bulk_m/ radsw_m,radlw_m,prate_m,
     &                       tair_m,rhum_m,uwnd_m,vwnd_m
      real*8 shflx_rsw,shflx_lat,shflx_sen,shflx_rlw
      common /forces_bulk_out/ shflx_rsw,shflx_lat,shflx_sen,shflx_rlw
      real*8 vonKar
      parameter (vonKar=0.41)
      real*8 Akt(0:N,NT)
     &                ,ghats(0:N)
      common /trac_mixing/ Akt
     &                    ,ghats
      real*8 z_bl
      common /kpp_scalars/ z_bl
      real*8 Kv(0:N)
      common /moment_mixing/ Kv
      real*8 Kt(0:N)
      equivalence (Kt(0),Akt(0,itemp))
      real*8 Ks(0:N)
      equivalence (Ks(0),Akt(0,isalt))
      real*8 time,tdays
      integer*4 iic,nstp,nnew
      common /time_indices/ time,tdays,iic,nstp,nnew
      real*8 dt, f, R0,Tcoef,Scoef, twrite
      integer*4 ntstart,ntimes,nwrite,noutput,nplot
      common /scalars/ ntstart,ntimes,nwrite,noutput,nplot,
     &                 dt,f,twrite,R0,Tcoef,Scoef
      real*8 nubl, cs, Cv, Ricr, betaT, epsilon, cekman, cmonob,
     &                               Cstar, Cg, Vtc, nu0c, eps
      parameter (
     &   nubl=0.1,
     &   cs=98.96,
     &   Cv=1.8,
     &   Ricr=0.15,
     &   betaT=-0.2,
     &   epsilon=0.1,
     &   cekman=0.7,
     &   cmonob=1.,
     &   Cstar=10.,
     &   nu0c=0.1,
     &   eps=1.E-20 )
      real*8 rho_surf,u_surf,v_surf, rho_k,u_k,v_k
      Cg=Cstar*vonKar*(cs*vonKar*epsilon)**(1./3.)
      Vtc=Cv * (-betaT/(cs*epsilon))**0.5 / (Ricr*vonKar**2)
      call alfabeta (alpha,beta)
      Bo=g*( alpha*(stflx(itemp)-srflx)
     &               -beta*stflx(isalt)
     &                                )
      Bosol=g*alpha*srflx
      do k=N,1,-1
        call lmd_swfrac (+1.,z_w(k),swdk)
        Bfsfc(k)=Bo+Bosol*(1.-swdk)
      enddo
      Bfsfc(0)=0.
      ustar=sqrt(sqrt(sustr**2+svstr**2))
      surf_dpth=(z_w(N)-z_bl)*epsilon
      rho_surf=rho1(N)
      u_surf=u(N,nstp)
      v_surf=v(N,nstp)
      Cr(N)=0.
      do k=N,1,-1
        dpth=z_w(N)-z_w(k-1)
        if (Bfsfc(k-1).lt.0) then
          zscale=min(surf_dpth,dpth)
        else
          zscale=dpth
        endif
        call lmd_wscale (Bfsfc(k-1),zscale,ustar, wm,ws)
        rho_k=rho1(k)
        u_k=u(k,nstp)
        v_k=v(k,nstp)
        Cr(k-1)=-g*(rho_surf-rho_k)*dpth
     &          -Ricr*rho0*( (u_surf-u_k)**2+(v_surf-v_k)**2
     &               +Vtc*dpth*ws*sqrt(abs(bvf(k))) )
       enddo
      kbl=1
      do k=N,2,-1
        if (kbl.eq.1 .and. Cr(k-1).gt.0.) kbl=k
      enddo
      if (kbl.eq.1) then
        z_bl=z_w(kbl)
      else
        z_bl=( z_w(kbl)*Cr(kbl-1)-z_w(kbl-1)*Cr(kbl)
     &                          )/(Cr(kbl-1)-Cr(kbl))
      endif
      call lmd_swfrac (+1.,z_bl,swdk)
      Bfsfc_bl=Bo+Bosol*(1.-swdk)
      if (Bfsfc_bl.gt.0.) then
        hekman=cekman*ustar/max(abs(f),eps)
        z_bl=z_w(N)-min( z_w(N)-z_bl, hekman)
      endif
      kbl=1
      do k=N,2,-1
        if (kbl.eq.1 .and. z_w(k-1).lt.z_bl) kbl=k
      enddo
      call lmd_swfrac (+1.,z_bl,swdk)
      Bfsfc_bl=Bo+Bosol*(1.-swdk)
      stable=0.5+sign(0.5,Bfsfc_bl)
      if (Bfsfc_bl.gt.0.) then
        cff=1.
      else
        cff=epsilon
      endif
      zscale=cff*(z_w(N)-z_bl)
      call lmd_wscale (Bfsfc_bl,zscale,ustar, wm,ws)
      f1=5.*max(0.,Bfsfc_bl)*vonKar/(ustar**4+eps)
      cff=1./(z_w(kbl)-z_w(kbl-1))
      cff_up=cff*(z_bl-z_w(kbl-1))
      cff_dn=cff*(z_w(kbl) -z_bl)
      K_bl=cff_up*Kv(kbl)+cff_dn*Kv(kbl-1)
      dK_bl=cff * (Kv(kbl)   -    Kv(kbl-1))
      Gm1=K_bl/((z_w(N)-z_bl)*wm+eps)
      dGm1dS=min(0., K_bl*f1-dK_bl/(wm+eps))
      K_bl=cff_up*Kt(kbl)+cff_dn*Kt(kbl-1)
      dK_bl=cff * (Kt(kbl)   -    Kt(kbl-1))
      Gt1=K_bl/((z_w(N)-z_bl)*ws+eps)
      dGt1dS=min(0., K_bl*f1-dK_bl/(ws+eps))
      K_bl=cff_up*Ks(kbl)+cff_dn*Ks(kbl-1)
      dK_bl=cff * (Ks(kbl)   -    Ks(kbl-1))
      Gs1=K_bl/((z_w(N)-z_bl)*ws+eps)
      dGs1dS=min(0., K_bl*f1-dK_bl/(ws+eps))
      surf_dpth=(z_w(N)-z_bl)*epsilon
      do k=N-1,kbl,-1
        dpth=z_w(N)-z_w(k)
        if (Bfsfc(k).lt.0) then
          zscale=min(surf_dpth,dpth)
        else
          zscale=dpth
        endif
        call lmd_wscale (Bfsfc(k),zscale,ustar, wm,ws)
        sgm=dpth/(z_w(N)-z_bl+eps)
        a1=sgm-2.
        a2=3.-2.*sgm
        a3=sgm-1.
        Kv(k)=wm*dpth*(1.+sgm*(a1+a2*Gm1+a3*dGm1dS))
        Kt(k)=ws*dpth*(1.+sgm*(a1+a2*Gt1+a3*dGt1dS))
        Ks(k)=ws*dpth*(1.+sgm*(a1+a2*Gs1+a3*dGs1dS))
        if (Bfsfc(k).le.0.) then
          ghats(k)=Cg * sgm*(1.-sgm)**2
        else
          ghats(k)=0.
        endif
      enddo
      do k=kbl-1,0,-1
        ghats(k)=0.
        if (rho1(k+1).gt.rho1(k)) then
          Kv(k)=Kv(k)+nu0c
          Kt(k)=Kt(k)+nu0c
        endif
      enddo
      return
      end
