      subroutine lmd_vmix
      implicit none
      integer*4 N
      parameter (N=100)
      integer*4 NT, itemp, isalt
      parameter (itemp=1, isalt=2)
      parameter (NT=2)
      real*8 pi, g, rho0, Cp, ods, ds, day2sec, sec2day,
     &                                  deg2rad, rad2deg
      parameter (pi=3.14159265358979323846,
     &           g=9.81, rho0=1025., Cp=3985.0,
     &           ods=N, ds=1./ods,
     &           day2sec=86400., sec2day=1./86400.,
     &           deg2rad=pi/180., rad2deg=180./pi)
      real*8 z_r(N),z_w(0:N),Hz(N), hmax, theta_s
      common /grid/ z_r,z_w,Hz,hmax,theta_s
      real*8 u(N,2),   v(N,2),  w(0:N),   t(N,2,NT),
     &     rhop0(N), rho1(N), bvf(0:N), tnudge(N,NT),  delta(N)
      common /ocean/ u,v,w,t, rhop0, rho1, bvf, tnudge, delta
      real*8 vonKar
      parameter (vonKar=0.41)
      real*8 Akt(0:N,NT)
     &                ,ghats(0:N)
      common /trac_mixing/ Akt
     &                    ,ghats
      real*8 z_bl
      common /kpp_scalars/ z_bl
      real*8 Kv(0:N)
      common /moment_mixing/ Kv
      real*8 Kt(0:N)
      equivalence (Kt(0),Akt(0,itemp))
      real*8 Ks(0:N)
      equivalence (Ks(0),Akt(0,isalt))
      real*8 time,tdays
      integer*4 iic,nstp,nnew
      common /time_indices/ time,tdays,iic,nstp,nnew
      real*8 dt, f, R0,Tcoef,Scoef, twrite
      integer*4 ntstart,ntimes,nwrite,noutput,nplot
      common /scalars/ ntstart,ntimes,nwrite,noutput,nplot,
     &                 dt,f,twrite,R0,Tcoef,Scoef
      real*8 Ri0, nuwm, nuws,  nu0m,   nu0s,  nu0c, nu,   Rrho0,
     &     nuf, fdd,  tdd1,  tdd2,   tdd3,  sdd1, sdd2, sdd3, eps
      parameter (
     &     Ri0=0.7,
     &     nuwm=1.0e-4,
     &     nuws=1.0e-5,
     &     nu0m=50.e-4,
     &     nu0s=50.e-4,
     &     nu0c=0.1,
     &     nu=1.5e-6,
     &     Rrho0=1.9,
     &     nuf=10.0e-4,
     &     fdd=0.7,
     &     tdd1=0.909,
     &     tdd2=4.6,
     &     tdd3=0.54,
     &     sdd1=0.15,
     &     sdd2=1.85,
     &     sdd3=0.85)
      integer*4 k
      real*8 nu_sx, RiRi0
      real*8 Rrho, ddDS, ddDT, nu_dds, nu_ddt, alfaobeta, Tt, Ts, Tp
      real*8 A0,A1,A2,A3,A4, B0,B1, C0, D0,D1,D2, E0,F0,G0,H0, Smean
      parameter(A0=+0.665157E-01, A1=+0.170907E-01, A2=-0.203814E-03,
     &          A3=+0.298357E-05, A4=-0.255019E-07, B0=+0.378110E-02,
     &          B1=-0.846960E-04, C0=-0.678662E-05, D0=+0.380374E-04,
     &          D1=-0.933746E-06, D2=+0.791325E-08, E0=-0.164759E-06,
     &          F0=-0.251520E-11, G0=+0.512857E-12, H0=-0.302285E-13,
     &          Smean=35.0)
      parameter (eps=1.E-14)
      do k=1,N-1
        Kv(k)=nuwm
        Kt(k)=nuws
        RiRi0=min( 1., max( 0., -g*(rho1(k+1)-rho1(k))
     &                                     *(z_r(k+1)-z_r(k))
     &                             /( rho0*Ri0*(
     &                                 (u(k+1,nstp)-u(k,nstp))**2
     &                                +(v(k+1,nstp)-v(k,nstp))**2
     &                                                    +eps ))
     &                                                        ))
        nu_sx=(1.-RiRi0**2)**3
        Kv(k)=Kv(k)+nu0m*nu_sx
        Kt(k)=Kt(k)+nu0s*nu_sx
        Ks(k)=Kt(k)
        Tt=0.5*(t(k,nstp,itemp)+t(k+1,nstp,itemp))
        Ts=0.5*(t(k,nstp,isalt)+t(k+1,nstp,isalt))-Smean
        Tp=-z_w(k)
        alfaobeta=A0+Tt*(A1+Tt*(A2+Tt*(A3+Tt*A4)))
     &              +Ts*(B0+Tt*B1+Ts*C0)
     &              +Tp*( D0+Tt*(D1+Tt*D2)+Ts*E0
     &                   +Tp*(Ts*F0+Tt*Tt*G0+Tp*H0))
        ddDT=t(k+1,nstp,itemp)-t(k,nstp,itemp)
        ddDS=t(k+1,nstp,isalt)-t(k,nstp,isalt)
        ddDS=sign(1.,ddDS)*max(abs(ddDS),eps)
        Rrho=alfaobeta*ddDT/ddDS
        if (Rrho.gt.1. .and. ddDS.gt.0.) then
          Rrho=min(Rrho,Rrho0)
          nu_dds=nuf*( 1.-((Rrho-1.)/(Rrho0-1.))**2 )**3
          nu_ddt=fdd*nu_dds
        elseif (Rrho.lt.1. .and. Rrho.gt.0. .and. ddDS.lt.0.) then
          nu_ddt=nu*tdd1*exp( tdd2*exp( -tdd3*( (1./Rrho)-1. )))
          if (Rrho.lt.0.5) then
            nu_dds=nu_ddt*sdd1*Rrho
          else
            nu_dds=nu_ddt*(sdd2*Rrho-sdd3)
          endif
        else
          nu_ddt=0.
          nu_dds=0.
        endif
        Kt(k)=Kt(k)+nu_ddt
        Ks(k)=Ks(k)+nu_dds
      enddo
      Kv(0)=Kv(  1)
      Kv(N)=Kv(N-1)
      Kt(0)=Kt(  1)
      Kt(N)=Kt(N-1)
      Ks(0)=Ks(  1)
      Ks(N)=Ks(N-1)
      return
      end
