      subroutine lmd_wscale (Bfsfc,zscale,ustar, wm,ws)
      implicit none
      real*8 Bfsfc,zscale,ustar, wm,ws
      integer*4 N
      parameter (N=100)
      integer*4 NT, itemp, isalt
      parameter (itemp=1, isalt=2)
      parameter (NT=2)
      real*8 pi, g, rho0, Cp, ods, ds, day2sec, sec2day,
     &                                  deg2rad, rad2deg
      parameter (pi=3.14159265358979323846,
     &           g=9.81, rho0=1025., Cp=3985.0,
     &           ods=N, ds=1./ods,
     &           day2sec=86400., sec2day=1./86400.,
     &           deg2rad=pi/180., rad2deg=180./pi)
      real*8 z_r(N),z_w(0:N),Hz(N), hmax, theta_s
      common /grid/ z_r,z_w,Hz,hmax,theta_s
      real*8 vonKar
      parameter (vonKar=0.41)
      real*8 Akt(0:N,NT)
     &                ,ghats(0:N)
      common /trac_mixing/ Akt
     &                    ,ghats
      real*8 z_bl
      common /kpp_scalars/ z_bl
      real*8 Kv(0:N)
      common /moment_mixing/ Kv
      real*8 Kt(0:N)
      equivalence (Kt(0),Akt(0,itemp))
      real*8 Ks(0:N)
      equivalence (Ks(0),Akt(0,isalt))
      real*8 ustar3, zetahat, zetapar
      real*8 zetam,zetas, am,cm, as,cs, eps, r2, r3, r4
      parameter (
     &    zetam=-0.2,
     &    zetas=-1.0,
     &    am=1.257,
     &    as=-28.86,
     &    cm=8.360,
     &    cs=98.96,
     &    eps=1.E-20,
     &    r2=0.5, r3=1./3., r4=0.25)
      ustar3=ustar**3
      zetahat=vonKar*zscale*Bfsfc
      zetapar=zetahat/(ustar3+eps)
      if (zetahat.ge.0.) then
        wm=vonKar*ustar/(1.+5.*zetapar)
        ws=wm
      else
        if (zetapar.gt.zetam) then
          wm=vonKar*ustar*(1.-16.*zetapar)**r4
        else
          wm=vonKar*(am*ustar3-cm*zetahat)**r3
        endif
        if (zetapar.gt.zetas) then
          ws=vonKar*ustar*(1.-16.*zetapar)**r2
        else
          ws=vonKar*(as*ustar3-cs*zetahat)**r3
        endif
      endif
      return
      end
