      implicit none
      integer*4 N
      parameter (N=100)
      integer*4 NT, itemp, isalt
      parameter (itemp=1, isalt=2)
      parameter (NT=2)
      real*8 pi, g, rho0, Cp, ods, ds, day2sec, sec2day,
     &                                  deg2rad, rad2deg
      parameter (pi=3.14159265358979323846,
     &           g=9.81, rho0=1025., Cp=3985.0,
     &           ods=N, ds=1./ods,
     &           day2sec=86400., sec2day=1./86400.,
     &           deg2rad=pi/180., rad2deg=180./pi)
      real*8 z_r(N),z_w(0:N),Hz(N), hmax, theta_s
      common /grid/ z_r,z_w,Hz,hmax,theta_s
      real*8 u(N,2),   v(N,2),  w(0:N),   t(N,2,NT),
     &     rhop0(N), rho1(N), bvf(0:N), tnudge(N,NT),  delta(N)
      common /ocean/ u,v,w,t, rhop0, rho1, bvf, tnudge, delta
      real*8 sustr,svstr,srflx,stflx(NT),upwi
      common /forces/ sustr,svstr,srflx,stflx,upwi
      real*8 sustr_m(12), svstr_m(12), stflx_m(12),
     &     ssflx_m(12), sst_m(12), dqdt_m(12), srflx_m(12), upwi_m(12)
      common /forces_m/ sustr_m, svstr_m, stflx_m,
     &                  ssflx_m, sst_m, dqdt_m, srflx_m, upwi_m
      real*8 sstsk, dtw1
      common /forces_sstsk/ sstsk, dtw1
      real*8 lonr,latr,
     &     radsw,radlw,prate,tair,rhum,uwnd,vwnd,wspd
      common /forces_bulk/ lonr,latr,
     &     radsw,radlw,prate,tair,rhum,uwnd,vwnd,wspd
      real*8 radsw_m(12),radlw_m(12),prate_m(12),
     &     tair_m(12),rhum_m(12),uwnd_m(12),vwnd_m(12)
      common /forces_bulk_m/ radsw_m,radlw_m,prate_m,
     &                       tair_m,rhum_m,uwnd_m,vwnd_m
      real*8 shflx_rsw,shflx_lat,shflx_sen,shflx_rlw
      common /forces_bulk_out/ shflx_rsw,shflx_lat,shflx_sen,shflx_rlw
      real*8 vonKar
      parameter (vonKar=0.41)
      real*8 Akt(0:N,NT)
     &                ,ghats(0:N)
      common /trac_mixing/ Akt
     &                    ,ghats
      real*8 z_bl
      common /kpp_scalars/ z_bl
      real*8 Kv(0:N)
      common /moment_mixing/ Kv
      real*8 Kt(0:N)
      equivalence (Kt(0),Akt(0,itemp))
      real*8 Ks(0:N)
      equivalence (Ks(0),Akt(0,isalt))
      real*8 time,tdays
      integer*4 iic,nstp,nnew
      common /time_indices/ time,tdays,iic,nstp,nnew
      real*8 dt, f, R0,Tcoef,Scoef, twrite
      integer*4 ntstart,ntimes,nwrite,noutput,nplot
      common /scalars/ ntstart,ntimes,nwrite,noutput,nplot,
     &                 dt,f,twrite,R0,Tcoef,Scoef
      integer*4 k,itrc,nrestart,itout,irestart
      real*8 time_start,cff,nudg_days,
     &     run_days,write_days,plot_days,output_days,restart_days
      real*4 zout(N),uout(N),vout(N),tout(N,NT),aktout(N),zblout
      real*4 tskout
      real*4 rswout,rlwout,latout,senout,susout,svsout
      integer*4 idiz,iuni
      character*7 tfile
      character*16 form
      real*8 duout(N),dvout(N),dtout(N,NT)
      dt       = 30.
      hmax     = 200.
      theta_s  = 2.
      tdays    = 0.
      run_days     = 720.
      nudg_days    = 360.
      write_days   = 1.
      plot_days    = 1.
      output_days  = 1./8.
      restart_days = 30.
      twrite       = 1.
      time     = tdays*day2sec
      ntimes   = int((run_days*day2sec+0.001)/dt)
      nwrite   = int((write_days*day2sec+0.001)/dt)
      nplot    = int((plot_days*day2sec+0.001)/dt)
      noutput  = int((output_days*day2sec+0.001)/dt)
      nrestart = int((restart_days*day2sec+0.001)/dt)
      iic=0
      ntstart=1
      nstp=1
      nnew=1
      call setup_grid
      call init_forces
      call setup_initial
        do k=1,N
           delta(k)=1./(nudg_days*86400.)
        enddo
       open(21,file='u.dat',form='formatted',status='unknown')
       open(22,file='v.dat',form='formatted',status='unknown')
       open(24,file='z.dat',form='formatted',status='unknown')
       open(25,file='days.dat',form='formatted',status='unknown')
       open(26,file='zbl.dat',form='formatted',status='unknown')
       do itrc=1,NT
          idiz=int(itrc/10)
          iuni=itrc-10*idiz
          write(tfile,1000) idiz,iuni
          open(26+itrc,file=tfile,form='formatted',status='unknown')
       enddo
 1000  format('t',i1,i1,'.dat')
       write(form,3000) N
 3000  format('(',i4,'(1x,g12.6))')
       open(26+NT+1,file='akt.dat',form='formatted',status='unknown')
       open(26+NT+2,file='tsk.dat',form='formatted',status='unknown')
       open(26+NT+3,file='rsw.dat',form='formatted',status='unknown')
       open(26+NT+4,file='rlw.dat',form='formatted',status='unknown')
       open(26+NT+5,file='lat.dat',form='formatted',status='unknown')
       open(26+NT+6,file='sen.dat',form='formatted',status='unknown')
       open(26+NT+7,file='sus.dat',form='formatted',status='unknown')
       open(26+NT+8,file='svs.dat',form='formatted',status='unknown')
       do k=1,N
         zout(k)=sngl(z_r(k))
         uout(k)=sngl(u(k,nstp))
         vout(k)=sngl(v(k,nstp))
         do itrc=1,NT
           tout(k,itrc)=sngl(t(k,nstp,itrc))
         enddo
         aktout(k)=sngl(Kt(k))
       enddo
       zblout=sngl(z_bl)
       tskout=sngl(sstsk)
       rswout=sngl(shflx_rsw)
       rlwout=sngl(shflx_rlw)
       latout=sngl(shflx_lat)
       senout=sngl(shflx_sen)
       susout=sngl(rho0*sustr)
       svsout=sngl(rho0*svstr)
       itout=1
       write(70) zout
       write(70) uout,vout,tout,zblout
       write(21,form) (uout(k),k=1,N)
       write(22,form) (vout(k),k=1,N)
       write(24,form) (zout(k),k=1,n)
       write(25,*) 0.
       write(26,*) zblout
       do itrc=1,NT
          write(26+itrc,form) (tout(k,itrc),k=1,N)
       enddo
       write(26+NT+1,form) (1.e4*aktout(k),k=1,N)
       write(26+NT+2,form) tskout
       write(26+NT+3,form) rswout
       write(26+NT+4,form) rlwout
       write(26+NT+5,form) latout
       write(26+NT+6,form) senout
       write(26+NT+7,form) susout
       write(26+NT+8,form) svsout
       irestart=1
       do k=1,N
         duout(k)=u(k,nnew)
         dvout(k)=v(k,nnew)
         do itrc=1,NT
           dtout(k,itrc)=t(k,nnew,itrc)
         enddo
       enddo
       itout=itout+1
       write(50) duout,dvout,dtout
      time_start=time
      do iic=ntstart,ntimes+1
        time=time_start+dt*float(iic-ntstart)
        tdays=time*sec2day
        if (mod(iic-ntstart,nwrite).eq.0) write(6,999) iic,tdays
 999    format('IIC - TDAYS = ',i10,f10.2)
        nstp=1+mod(iic-ntstart,2)
        nnew=3-nstp
        call set_forces
        call bulk_flux
        call sst_skin
        call rho_eos
        call lmd_vmix
        call lmd_kpp
        call step3d
        if (tdays.gt.twrite.and.mod(iic-ntstart,noutput).eq.0) then
          do k=1,N
            uout(k)=sngl(u(k,nnew))
            vout(k)=sngl(v(k,nnew))
            do itrc=1,NT
              tout(k,itrc)=sngl(t(k,nnew,itrc))
            enddo
            aktout(k)=sngl(Kt(k))
          enddo
          zblout=sngl(z_bl)
          tskout=sngl(sstsk)
          rswout=sngl(shflx_rsw)
          rlwout=sngl(shflx_rlw)
          latout=sngl(shflx_lat)
          senout=sngl(shflx_sen)
          susout=sngl(rho0*sustr)
          svsout=sngl(rho0*svstr)
          itout=itout+1
          write(70) uout,vout,tout,zblout
          write(21,form) (uout(k),k=1,N)
          write(22,form) (vout(k),k=1,N)
          write(25,*) tdays
          write(26,*) zblout
          do itrc=1,NT
             write(26+itrc,form) (tout(k,itrc),k=1,N)
          enddo
          write(26+NT+1,form) (1.e4*aktout(k),k=1,N)
          write(26+NT+2,form) tskout
          write(26+NT+3,form) rswout
          write(26+NT+4,form) rlwout
          write(26+NT+5,form) latout
          write(26+NT+6,form) senout
          write(26+NT+7,form) susout
          write(26+NT+8,form) svsout
        endif
        if (mod(iic-ntstart,nrestart).eq.0) then
          irestart=irestart+1
          do k=1,N
            duout(k)=u(k,nnew)
            dvout(k)=v(k,nnew)
            do itrc=1,NT
              dtout(k,itrc)=t(k,nnew,itrc)
            enddo
          enddo
          write(*,*) 'WRITING RESTART FILE NUMBER: ',irestart
          write(50) duout,dvout,dtout
          write(51,*) irestart
        endif
        nnew=3-nstp
      enddo
      write(*,*) 'TOTAL NUMBER OF BINARY OUTPUTS = ',itout
       close(21)
       close(22)
       close(24)
       close(25)
       close(26)
       do itrc=1,NT
          close(26+itrc)
       enddo
       close(26+itrc+1)
       close(26+itrc+2)
       close(26+itrc+3)
       close(26+itrc+4)
       close(26+itrc+5)
       close(26+itrc+6)
       close(26+itrc+7)
       close(26+itrc+8)
      stop
      end
