      subroutine init_forces
      implicit none
      integer*4 N
      parameter (N=100)
      integer*4 NT, itemp, isalt
      parameter (itemp=1, isalt=2)
      parameter (NT=2)
      real*8 pi, g, rho0, Cp, ods, ds, day2sec, sec2day,
     &                                  deg2rad, rad2deg
      parameter (pi=3.14159265358979323846,
     &           g=9.81, rho0=1025., Cp=3985.0,
     &           ods=N, ds=1./ods,
     &           day2sec=86400., sec2day=1./86400.,
     &           deg2rad=pi/180., rad2deg=180./pi)
      real*8 time,tdays
      integer*4 iic,nstp,nnew
      common /time_indices/ time,tdays,iic,nstp,nnew
      real*8 dt, f, R0,Tcoef,Scoef, twrite
      integer*4 ntstart,ntimes,nwrite,noutput,nplot
      common /scalars/ ntstart,ntimes,nwrite,noutput,nplot,
     &                 dt,f,twrite,R0,Tcoef,Scoef
      real*8 sustr,svstr,srflx,stflx(NT),upwi
      common /forces/ sustr,svstr,srflx,stflx,upwi
      real*8 sustr_m(12), svstr_m(12), stflx_m(12),
     &     ssflx_m(12), sst_m(12), dqdt_m(12), srflx_m(12), upwi_m(12)
      common /forces_m/ sustr_m, svstr_m, stflx_m,
     &                  ssflx_m, sst_m, dqdt_m, srflx_m, upwi_m
      real*8 sstsk, dtw1
      common /forces_sstsk/ sstsk, dtw1
      real*8 lonr,latr,
     &     radsw,radlw,prate,tair,rhum,uwnd,vwnd,wspd
      common /forces_bulk/ lonr,latr,
     &     radsw,radlw,prate,tair,rhum,uwnd,vwnd,wspd
      real*8 radsw_m(12),radlw_m(12),prate_m(12),
     &     tair_m(12),rhum_m(12),uwnd_m(12),vwnd_m(12)
      common /forces_bulk_m/ radsw_m,radlw_m,prate_m,
     &                       tair_m,rhum_m,uwnd_m,vwnd_m
      real*8 shflx_rsw,shflx_lat,shflx_sen,shflx_rlw
      common /forces_bulk_out/ shflx_rsw,shflx_lat,shflx_sen,shflx_rlw
      real*8 ss_ave,st_ave
      integer*4 i,iocheck,ierr
      ierr=0
      open(11,file='forces.data', status='old', form='formatted')
      read(11,*)
      read(11,*)
      read(11,*)
      read(11,*,iostat=iocheck) lonr,latr
      if (iocheck.ne.0) ierr=ierr+1
      if(iocheck.ne.0) write(*,*)
     &          'SETUP_INITIAL: Cannot read LON LAT'
      read(11,*)
      read(11,*)
      read(11,*,iostat=iocheck) (sustr_m(i),i=1, 6)
      if (iocheck.ne.0) ierr=ierr+1
      read(11,*,iostat=iocheck) (sustr_m(i),i=7,12)
      if (iocheck.ne.0) ierr=ierr+1
      if(iocheck.ne.0) write(*,*) 'Cannot read SUSTR'
      read(11,*)
      read(11,*)
      read(11,*,iostat=iocheck) (svstr_m(i),i=1, 6)
      if (iocheck.ne.0) ierr=ierr+1
      read(11,*,iostat=iocheck) (svstr_m(i),i=7,12)
      if (iocheck.ne.0) ierr=ierr+1
      if(iocheck.ne.0) write(*,*) 'Cannot read SVSTR'
      read(11,*)
      read(11,*)
      read(11,*,iostat=iocheck) (stflx_m(i),i=1, 6)
      if (iocheck.ne.0) ierr=ierr+1
      read(11,*,iostat=iocheck) (stflx_m(i),i=7,12)
      if (iocheck.ne.0) ierr=ierr+1
      if(iocheck.ne.0) write(*,*) 'Cannot read STFLX'
      read(11,*)
      read(11,*)
      read(11,*,iostat=iocheck) (ssflx_m(i),i=1, 6)
      if (iocheck.ne.0) ierr=ierr+1
      read(11,*,iostat=iocheck) (ssflx_m(i),i=7,12)
      if (iocheck.ne.0) ierr=ierr+1
      if(iocheck.ne.0) write(*,*) 'Cannot read SSFLX'
      read(11,*)
      read(11,*)
      read(11,*,iostat=iocheck)   (sst_m(i),i=1, 6)
      if (iocheck.ne.0) ierr=ierr+1
      read(11,*,iostat=iocheck)   (sst_m(i),i=7,12)
      if (iocheck.ne.0) ierr=ierr+1
      if(iocheck.ne.0) write(*,*) 'Cannot read SST'
      read(11,*)
      read(11,*)
      read(11,*,iostat=iocheck) (dqdt_m(i),i=1, 6)
      if (iocheck.ne.0) ierr=ierr+1
      read(11,*,iostat=iocheck) (dqdt_m(i),i=7,12)
      if (iocheck.ne.0) ierr=ierr+1
      if(iocheck.ne.0) write(*,*) 'Cannot read DQDT'
      read(11,*)
      read(11,*)
      read(11,*,iostat=iocheck) (srflx_m(i),i=1, 6)
      if (iocheck.ne.0) ierr=ierr+1
      read(11,*,iostat=iocheck) (srflx_m(i),i=7,12)
      if (iocheck.ne.0) ierr=ierr+1
      if(iocheck.ne.0) write(*,*) 'Cannot read SRFLX'
      read(11,*)
      read(11,*)
      read(11,*,iostat=iocheck) (upwi_m(i),i=1, 6)
      if (iocheck.ne.0) ierr=ierr+1
      read(11,*,iostat=iocheck) (upwi_m(i),i=7,12)
      if (iocheck.ne.0) ierr=ierr+1
      if(iocheck.ne.0) write(*,*) 'Cannot read UPWI'
      read(11,*)
      read(11,*)
      read(11,*,iostat=iocheck) (radsw_m(i),i=1, 6)
      if (iocheck.ne.0) ierr=ierr+1
      read(11,*,iostat=iocheck) (radsw_m(i),i=7,12)
      if (iocheck.ne.0) ierr=ierr+1
      if(iocheck.ne.0) write(*,*) 'Cannot read RADSW'
      read(11,*)
      read(11,*)
      read(11,*,iostat=iocheck) (radlw_m(i),i=1, 6)
      if (iocheck.ne.0) ierr=ierr+1
      read(11,*,iostat=iocheck) (radlw_m(i),i=7,12)
      if (iocheck.ne.0) ierr=ierr+1
      if(iocheck.ne.0) write(*,*) 'Cannot read RADLW'
      read(11,*)
      read(11,*)
      read(11,*,iostat=iocheck) (prate_m(i),i=1, 6)
      if (iocheck.ne.0) ierr=ierr+1
      read(11,*,iostat=iocheck) (prate_m(i),i=7,12)
      if (iocheck.ne.0) ierr=ierr+1
      if(iocheck.ne.0) write(*,*) 'Cannot read PRATE'
      read(11,*)
      read(11,*)
      read(11,*,iostat=iocheck) (tair_m(i),i=1, 6)
      if (iocheck.ne.0) ierr=ierr+1
      read(11,*,iostat=iocheck) (tair_m(i),i=7,12)
      if (iocheck.ne.0) ierr=ierr+1
      if(iocheck.ne.0) write(*,*) 'Cannot read TAIR'
      read(11,*)
      read(11,*)
      read(11,*,iostat=iocheck) (rhum_m(i),i=1, 6)
      if (iocheck.ne.0) ierr=ierr+1
      read(11,*,iostat=iocheck) (rhum_m(i),i=7,12)
      if (iocheck.ne.0) ierr=ierr+1
      if(iocheck.ne.0) write(*,*) 'Cannot read RHUM'
      read(11,*)
      read(11,*)
      read(11,*,iostat=iocheck) (uwnd_m(i),i=1, 6)
      if (iocheck.ne.0) ierr=ierr+1
      read(11,*,iostat=iocheck) (uwnd_m(i),i=7,12)
      if (iocheck.ne.0) ierr=ierr+1
      if(iocheck.ne.0) write(*,*) 'Cannot read UWND'
      read(11,*)
      read(11,*)
      read(11,*,iostat=iocheck) (vwnd_m(i),i=1, 6)
      if (iocheck.ne.0) ierr=ierr+1
      read(11,*,iostat=iocheck) (vwnd_m(i),i=7,12)
      if (iocheck.ne.0) ierr=ierr+1
      if(iocheck.ne.0) write(*,*) 'Cannot read VWND'
      close(11)
      if(ierr.eq.0) write(*,*) 'Read forces from datafile OK'
      st_ave=0.
      do i=1,12
        st_ave=st_ave+stflx_m(i)
      enddo
      st_ave=st_ave/12.
      do i=1,12
        stflx_m(i)=stflx_m(i)-st_ave
      enddo
      ss_ave=0.
      do i=1,12
        ss_ave=ss_ave+ssflx_m(i)
      enddo
      ss_ave=ss_ave/12.
      do i=1,12
        ssflx_m(i)=ssflx_m(i)-ss_ave
      enddo
      f=4*pi/86400*sin(latr*pi/180)
      return
      end
      subroutine set_forces
      implicit none
      integer*4 N
      parameter (N=100)
      integer*4 NT, itemp, isalt
      parameter (itemp=1, isalt=2)
      parameter (NT=2)
      real*8 pi, g, rho0, Cp, ods, ds, day2sec, sec2day,
     &                                  deg2rad, rad2deg
      parameter (pi=3.14159265358979323846,
     &           g=9.81, rho0=1025., Cp=3985.0,
     &           ods=N, ds=1./ods,
     &           day2sec=86400., sec2day=1./86400.,
     &           deg2rad=pi/180., rad2deg=180./pi)
      real*8 time,tdays
      integer*4 iic,nstp,nnew
      common /time_indices/ time,tdays,iic,nstp,nnew
      real*8 dt, f, R0,Tcoef,Scoef, twrite
      integer*4 ntstart,ntimes,nwrite,noutput,nplot
      common /scalars/ ntstart,ntimes,nwrite,noutput,nplot,
     &                 dt,f,twrite,R0,Tcoef,Scoef
      real*8 sustr,svstr,srflx,stflx(NT),upwi
      common /forces/ sustr,svstr,srflx,stflx,upwi
      real*8 sustr_m(12), svstr_m(12), stflx_m(12),
     &     ssflx_m(12), sst_m(12), dqdt_m(12), srflx_m(12), upwi_m(12)
      common /forces_m/ sustr_m, svstr_m, stflx_m,
     &                  ssflx_m, sst_m, dqdt_m, srflx_m, upwi_m
      real*8 sstsk, dtw1
      common /forces_sstsk/ sstsk, dtw1
      real*8 lonr,latr,
     &     radsw,radlw,prate,tair,rhum,uwnd,vwnd,wspd
      common /forces_bulk/ lonr,latr,
     &     radsw,radlw,prate,tair,rhum,uwnd,vwnd,wspd
      real*8 radsw_m(12),radlw_m(12),prate_m(12),
     &     tair_m(12),rhum_m(12),uwnd_m(12),vwnd_m(12)
      common /forces_bulk_m/ radsw_m,radlw_m,prate_m,
     &                       tair_m,rhum_m,uwnd_m,vwnd_m
      real*8 shflx_rsw,shflx_lat,shflx_sen,shflx_rlw
      common /forces_bulk_out/ shflx_rsw,shflx_lat,shflx_sen,shflx_rlw
      real*8 u(N,2),   v(N,2),  w(0:N),   t(N,2,NT),
     &     rhop0(N), rho1(N), bvf(0:N), tnudge(N,NT),  delta(N)
      common /ocean/ u,v,w,t, rhop0, rho1, bvf, tnudge, delta
      integer*4 indx, i,j, itrc
      real*8 sec2month, tau,cff1,cff2, cffM, cffT,cffS, cffW
      real*8 cff,fac1,fac2,cos_h,dec,cos_d,sin_d,tan_d,phi,h0
      parameter (sec2month=1./2592000., cffM=1./rho0,
     &           cffT=1./(rho0*Cp), cffS=0.01/86400.,
     &           cffW=1./(100.*300.e3) )
      tau=time*sec2month+0.5
      indx=int(tau)
      i=1+mod(indx+11,12)
      j=1+mod(indx   ,12)
      cff2=tau-float(indx)
      cff1=1.-cff2
      sustr=cffM*(cff1*sustr_m(i)+cff2*sustr_m(j))
      svstr=cffM*(cff1*svstr_m(i)+cff2*svstr_m(j))
      srflx=cffT*(cff1*srflx_m(i)+cff2*srflx_m(j))
      stflx(itemp)=cffT*( cff1*stflx_m(i)+cff2*stflx_m(j)
     &                  +(cff1*dqdt_m(i)+cff2*dqdt_m(j))
     &                    *(t(N,nstp,itemp)-cff1*sst_m(i)
     &                                     -cff2*sst_m(j))
     &                                                   )
      stflx(isalt)=cffS*t(N,nstp,isalt)*( cff1*ssflx_m(i)
     &                                   +cff2*ssflx_m(j))
      radsw=cffT*(cff1*radsw_m(i)+cff2*radsw_m(j))
      radlw=cffT*(cff1*radlw_m(i)+cff2*radlw_m(j))
      prate=cffS*(cff1*prate_m(i)+cff2*prate_m(j))
      tair=cff1*tair_m(i)+cff2*tair_m(j)
      rhum=cff1*rhum_m(i)+cff2*rhum_m(j)
      uwnd=cff1*uwnd_m(i)+cff2*uwnd_m(j)
      vwnd=cff1*vwnd_m(i)+cff2*vwnd_m(j)
      wspd=sqrt(uwnd*uwnd+vwnd*vwnd)
      upwi=cffW*(cff1*upwi_m(i)+cff2*upwi_m(j))
      return
      end
