      subroutine setup_initial
      implicit none
      integer*4 N
      parameter (N=100)
      integer*4 NT, itemp, isalt
      parameter (itemp=1, isalt=2)
      parameter (NT=2)
      real*8 pi, g, rho0, Cp, ods, ds, day2sec, sec2day,
     &                                  deg2rad, rad2deg
      parameter (pi=3.14159265358979323846,
     &           g=9.81, rho0=1025., Cp=3985.0,
     &           ods=N, ds=1./ods,
     &           day2sec=86400., sec2day=1./86400.,
     &           deg2rad=pi/180., rad2deg=180./pi)
      real*8 time,tdays
      integer*4 iic,nstp,nnew
      common /time_indices/ time,tdays,iic,nstp,nnew
      real*8 dt, f, R0,Tcoef,Scoef, twrite
      integer*4 ntstart,ntimes,nwrite,noutput,nplot
      common /scalars/ ntstart,ntimes,nwrite,noutput,nplot,
     &                 dt,f,twrite,R0,Tcoef,Scoef
      real*8 z_r(N),z_w(0:N),Hz(N), hmax, theta_s
      common /grid/ z_r,z_w,Hz,hmax,theta_s
      real*8 u(N,2),   v(N,2),  w(0:N),   t(N,2,NT),
     &     rhop0(N), rho1(N), bvf(0:N), tnudge(N,NT),  delta(N)
      common /ocean/ u,v,w,t, rhop0, rho1, bvf, tnudge, delta
      real*8 vonKar
      parameter (vonKar=0.41)
      real*8 Akt(0:N,NT)
     &                ,ghats(0:N)
      common /trac_mixing/ Akt
     &                    ,ghats
      real*8 z_bl
      common /kpp_scalars/ z_bl
      real*8 Kv(0:N)
      common /moment_mixing/ Kv
      real*8 Kt(0:N)
      equivalence (Kt(0),Akt(0,itemp))
      real*8 Ks(0:N)
      equivalence (Ks(0),Akt(0,isalt))
      real*8 sustr,svstr,srflx,stflx(NT),upwi
      common /forces/ sustr,svstr,srflx,stflx,upwi
      real*8 sustr_m(12), svstr_m(12), stflx_m(12),
     &     ssflx_m(12), sst_m(12), dqdt_m(12), srflx_m(12), upwi_m(12)
      common /forces_m/ sustr_m, svstr_m, stflx_m,
     &                  ssflx_m, sst_m, dqdt_m, srflx_m, upwi_m
      real*8 sstsk, dtw1
      common /forces_sstsk/ sstsk, dtw1
      real*8 lonr,latr,
     &     radsw,radlw,prate,tair,rhum,uwnd,vwnd,wspd
      common /forces_bulk/ lonr,latr,
     &     radsw,radlw,prate,tair,rhum,uwnd,vwnd,wspd
      real*8 radsw_m(12),radlw_m(12),prate_m(12),
     &     tair_m(12),rhum_m(12),uwnd_m(12),vwnd_m(12)
      common /forces_bulk_m/ radsw_m,radlw_m,prate_m,
     &                       tair_m,rhum_m,uwnd_m,vwnd_m
      real*8 shflx_rsw,shflx_lat,shflx_sen,shflx_rlw
      common /forces_bulk_out/ shflx_rsw,shflx_lat,shflx_sen,shflx_rlw
      integer*4 k,i,iocheck,ierr
      real*8 coef1,coef2,coef3,coef4,coef5,coef6,cff
      real*8 Zwoa(24),Twoa(24),Swoa(24),Nwoa(24)
      ierr=0
      open(11,file='clim.data', status='old', form='formatted')
      read(11,*)
      read(11,*)
      read(11,*)
      read(11,*)
      read(11,*,iostat=iocheck) (Zwoa(i),i=1,12)
      if (iocheck.ne.0) ierr=ierr+1
      read(11,*,iostat=iocheck) (Zwoa(i),i=13,24)
      if (iocheck.ne.0) ierr=ierr+1
      if (iocheck.ne.0) write(*,*) 'Cannot read Zwoa'
      read(11,*)
      read(11,*)
      read(11,*,iostat=iocheck) (Twoa(i),i=1,12)
      if (iocheck.ne.0) ierr=ierr+1
      read(11,*,iostat=iocheck) (Twoa(i),i=13,24)
      if (iocheck.ne.0) ierr=ierr+1
      if (iocheck.ne.0) write(*,*) 'Cannot read Twoa'
      read(11,*)
      read(11,*)
      read(11,*,iostat=iocheck) (Swoa(i),i=1,12)
      if (iocheck.ne.0) ierr=ierr+1
      read(11,*,iostat=iocheck) (Swoa(i),i=13,24)
      if (iocheck.ne.0) ierr=ierr+1
      if (iocheck.ne.0) write(*,*) 'Cannot read Swoa'
      close(11)
      if (ierr.eq.0) write(*,*) 'Read T,S profiles from datafile OK'
      do k=1,N
        u(k,nstp)=0.
        v(k,nstp)=0.
        do i=1,23
          if (z_r(k).ge.Zwoa(i) .and. z_r(k).lt.Zwoa(i+1)) then
            t(k,nstp,itemp)=( Twoa(i  )*(Zwoa(i+1)-z_r(k))+
     &                        Twoa(i+1)*(z_r(k)-Zwoa(i  )) )/
     &                        (Zwoa(i+1)-Zwoa(i))
            t(k,nstp,isalt)=( Swoa(i  )*(Zwoa(i+1)-z_r(k))+
     &                        Swoa(i+1)*(z_r(k)-Zwoa(i  )) )/
     &                        (Zwoa(i+1)-Zwoa(i))
          endif
        enddo
         tnudge(k,itemp)=t(k,nstp,itemp)
         tnudge(k,isalt)=t(k,nstp,isalt)
      enddo
      sstsk=t(N,nstp,itemp)
      dtw1=0.
      do k=1,N
        Kv(k)=0.01
        Akt(k,itemp)=0.001
        Akt(k,isalt)=0.001
      enddo
      return
      end
