      subroutine step3d
      implicit none
      integer*4 N
      parameter (N=100)
      integer*4 NT, itemp, isalt
      parameter (itemp=1, isalt=2)
      parameter (NT=2)
      real*8 pi, g, rho0, Cp, ods, ds, day2sec, sec2day,
     &                                  deg2rad, rad2deg
      parameter (pi=3.14159265358979323846,
     &           g=9.81, rho0=1025., Cp=3985.0,
     &           ods=N, ds=1./ods,
     &           day2sec=86400., sec2day=1./86400.,
     &           deg2rad=pi/180., rad2deg=180./pi)
      real*8 z_r(N),z_w(0:N),Hz(N), hmax, theta_s
      common /grid/ z_r,z_w,Hz,hmax,theta_s
      real*8 u(N,2),   v(N,2),  w(0:N),   t(N,2,NT),
     &     rhop0(N), rho1(N), bvf(0:N), tnudge(N,NT),  delta(N)
      common /ocean/ u,v,w,t, rhop0, rho1, bvf, tnudge, delta
      real*8 time,tdays
      integer*4 iic,nstp,nnew
      common /time_indices/ time,tdays,iic,nstp,nnew
      real*8 dt, f, R0,Tcoef,Scoef, twrite
      integer*4 ntstart,ntimes,nwrite,noutput,nplot
      common /scalars/ ntstart,ntimes,nwrite,noutput,nplot,
     &                 dt,f,twrite,R0,Tcoef,Scoef
      real*8 vonKar
      parameter (vonKar=0.41)
      real*8 Akt(0:N,NT)
     &                ,ghats(0:N)
      common /trac_mixing/ Akt
     &                    ,ghats
      real*8 z_bl
      common /kpp_scalars/ z_bl
      real*8 Kv(0:N)
      common /moment_mixing/ Kv
      real*8 Kt(0:N)
      equivalence (Kt(0),Akt(0,itemp))
      real*8 Ks(0:N)
      equivalence (Ks(0),Akt(0,isalt))
      real*8 sustr,svstr,srflx,stflx(NT),upwi
      common /forces/ sustr,svstr,srflx,stflx,upwi
      real*8 sustr_m(12), svstr_m(12), stflx_m(12),
     &     ssflx_m(12), sst_m(12), dqdt_m(12), srflx_m(12), upwi_m(12)
      common /forces_m/ sustr_m, svstr_m, stflx_m,
     &                  ssflx_m, sst_m, dqdt_m, srflx_m, upwi_m
      real*8 sstsk, dtw1
      common /forces_sstsk/ sstsk, dtw1
      real*8 lonr,latr,
     &     radsw,radlw,prate,tair,rhum,uwnd,vwnd,wspd
      common /forces_bulk/ lonr,latr,
     &     radsw,radlw,prate,tair,rhum,uwnd,vwnd,wspd
      real*8 radsw_m(12),radlw_m(12),prate_m(12),
     &     tair_m(12),rhum_m(12),uwnd_m(12),vwnd_m(12)
      common /forces_bulk_m/ radsw_m,radlw_m,prate_m,
     &                       tair_m,rhum_m,uwnd_m,vwnd_m
      real*8 shflx_rsw,shflx_lat,shflx_sen,shflx_rlw
      common /forces_bulk_out/ shflx_rsw,shflx_lat,shflx_sen,shflx_rlw
      integer*4 k,itrc
      real*8 Hz_inv(0:N), FC(0:N),BC,CF(0:N), DCu(0:N),DCv(0:N),
     &                  cff,cff1,cff2,cff3,cff6,swdk,lambda,
     &                  cu
      parameter (lambda=0.501)
      real*8 One, Two, Three, Half, ThreeHalfth
      parameter(One=1., Two=2., Three=3., Half=0.5, ThreeHalfth=1.5)
      do k=1,N
        Hz_inv(k)=ods/Hz(k)
      enddo
      do k=0,N
         w(k)=0.0
      enddo
      do itrc=1,NT
          FC(1)=Half
          CF(0)=ThreeHalfth*t(1,nstp,itrc)
          do k=1,N-1,+1
            cff=One/(Two*Hz(k)+Hz(k+1)*(Two-FC(k)))
            FC(k+1)=cff*Hz(k)
            CF(k)=cff*( Three*( t(k+1,nstp,itrc)*Hz(k)
     &                               +t(k,nstp,itrc)*Hz(k+1))
     &                                       -Hz(k+1)*CF(k-1))
          enddo
          CF(N)=(Three*t(N,nstp,itrc)-CF(N-1))/(Two-FC(N))
          do k=N-1,0,-1
            CF(k)=CF(k)-FC(k+1)*CF(k+1)
          enddo
          do k=1,N-1
            if (w(k).gt.0.) then
              cff=Hz_inv(k)
              cff1=CF(k-1)
              cff2=t(k,nstp,itrc)
            else
              cff=Hz_inv(k+1)
              cff1=CF(k+1)
              cff2=t(k+1,nstp,itrc)
            endif
            cu=dt*abs(w(k))*cff
            FC(k)=w(k)*( CF(k) -0.5*cu*( CF(k)-cff1
     &                  +(3.-2.*cu)*(CF(k)+cff1-2.*cff2)
     &                                               ))
          enddo
          FC(0)=0.
          FC(N)=0.
        do k=1,N
          t(k,nnew,itrc)=( t(k,nstp,itrc)-dt*Hz_inv(k)
     &                                 *(FC(k)-FC(k-1))
     &                )/( 1.-dt*Hz_inv(k)*(w(k)-w(k-1)))
        enddo
        CF(N)=stflx(itrc)
        if (itrc.eq.itemp) then
          do k=N-1,1,-1
            call lmd_swfrac (+1.,z_w(k),swdk)
            CF(k)=srflx*swdk
     &            -ghats(k)*(stflx(itemp)-srflx)
          enddo
        else
          do k=N-1,1,-1
            CF(k)=-ghats(k)*stflx(itrc)
          enddo
        endif
        CF(0)=0.
        do k=1,N
          t(k,nnew,itrc)=t(k,nnew,itrc)+dt*Hz_inv(k)*(CF(k)-CF(k-1))
        enddo
        cff6=ds/6.
        do k=1,N-1
          FC(k)=cff6*Hz(k  )-dt*Akt(k-1,itrc)*Hz_inv(k  )
          CF(k)=cff6*Hz(k+1)-dt*Akt(k+1,itrc)*Hz_inv(k+1)
        enddo
        CF(0)=0.
        DCu(0)=0.
        cff3=ds/3.
        do k=1,N-1,+1
          BC=cff3*(Hz(k)+Hz(k+1))+dt*Akt(k,itrc)*(
     &                     Hz_inv(k )+Hz_inv(k+1) )
          cff=1./(BC-FC(k)*CF(k-1))
          CF(k)=cff*CF(k)
          DCu(k)=cff*( t(k+1,nnew,itrc)-t(k,nnew,itrc)
     &                                -FC(k)*DCu(k-1) )
        enddo
        DCu(N)=0.
        do k=N-1,1,-1
          DCu(k)=DCu(k)-CF(k)*DCu(k+1)
        enddo
        do k=1,N-1,+1
           FC(k)=Akt(k,itrc)*0.166666666666667*(
     &           5.*DCu(k)+(Hz(k+1)*DCu(k-1)+Hz(k)*DCu(k+1))
     &                                   /(Hz(k)+Hz(k+1))
     &                                                  )
        enddo
        FC(0)=0.
        FC(N)=0.
        do k=1,N
           if (itrc.le.3) then
              cff1=delta(k)*(tnudge(k,itrc)-t(k,nnew,itrc))
           else
              cff1=0.
           endif
           t(k,nnew,itrc)=t(k,nnew,itrc)+dt*(
     &                     cff1+Hz_inv(k)*(FC(k)-FC(k-1)))
        enddo
      enddo
      cff=1./(1.+(lambda*dt*f)**2)
      cff1=cff*(1.-lambda*(1.-lambda)*(dt*f)**2)
      cff2=cff*dt*f
      do k=1,N
        u(k,nnew)=cff1*u(k,nstp)+cff2*v(k,nstp)
        v(k,nnew)=cff1*v(k,nstp)-cff2*u(k,nstp)
      enddo
      u(N,nnew)=u(N,nnew)+dt*Hz_inv(N)*sustr
      v(N,nnew)=v(N,nnew)+dt*Hz_inv(N)*svstr
      cff6=ds/6.
      do k=1,N-1
        FC(k)=cff6*Hz(k  )-dt*Kv(k-1)*Hz_inv(k  )
        CF(k)=cff6*Hz(k+1)-dt*Kv(k+1)*Hz_inv(k+1)
      enddo
      CF(0)=0.
      DCu(0)=0.
      DCv(0)=0.
      cff3=ds/3.
      do k=1,N-1,+1
        BC=cff3*(Hz(k)+Hz(k+1))+dt*Kv(k)*(
     &                   Hz_inv(k )+Hz_inv(k+1) )
        cff=1./(BC-FC(k)*CF(k-1))
        CF(k)=cff*CF(k)
        DCu(k)=cff*(u(k+1,nnew)-u(k,nnew) - FC(k)*DCu(k-1))
        DCv(k)=cff*(v(k+1,nnew)-v(k,nnew) - FC(k)*DCv(k-1))
      enddo
      DCu(N)=0.
      DCv(N)=0.
      do k=N-1,1,-1
        DCu(k)=DCu(k)-CF(k)*DCu(k+1)
        DCv(k)=DCv(k)-CF(k)*DCv(k+1)
      enddo
      do k=1,N,+1
        DCu(k)=DCu(k)*Kv(k)
        u(k,nnew)=u(k,nnew)+dt*Hz_inv(k)*(DCu(k)-DCu(k-1))
        DCv(k)=DCv(k)*Kv(k)
        v(k,nnew)=v(k,nnew)+dt*Hz_inv(k)*(DCv(k)-DCv(k-1))
      enddo
      return
      end
